<style>
    .container>dl{margin: 0.15rem 0rem;}
    .container>dl>dt{font-size: 0.18rem;}
    .container>dl>dd{margin: 0.05rem;}
    h5>a.active{
        color: red;
        transition:  0.6s;
        -moz-transition:  0.6s;  /* Firefox 4 */
        -webkit-transition:  0.6s;   /* Safari 和 Chrome */
        -o-transition:  0.6s;    /* Opera */
    }
    .demo{overflow: hidden;display: block;}
    .demo>code, .demo>div{width:49%;     border: 1px solid #9fbadb; padding: 15px 0px; overflow: hidden;}
    .demo>code{float: left;}
    .demo>div{float: right;}
    .demo .btn{border: 1px solid #e3e3e3; padding: 5px; border-radius: 5px; cursor: pointer; }

</style>
<div class="container" > 
    <script>
        $(function(){
            $('#hpre>a').each(function(){
                var m = /^\#(.*)/gi.exec( $(this).attr('href') );
                if(!m){return ; }
                $(this).click(function(){ active($('[name='+m[1]+']')); });

            });
        });
        function active(obj){
            $('a[name]').removeClass('active');
            $(obj).addClass('active');
        }
    </script>
    <pre id="hpre">
    new Vue({
        <a href="#el">'el'</a>:"#id", //DOM成员（1/3）
        <a href="#template">'template'</a>:"&lt;tag&gt;&lt;/tag&gt;", //DOM成员（2/3）
        <a href="#render">'render'</a>:function(createElement){ return createElement(App); }, //DOM成员（3/3） render函数，用来渲染根组件
        <a href="#data">'data'</a>:{}, //数据成员（1/6）
        <a href="#methods">'methods'</a>:{ fun1:function(){} }, //数据成员（2/6）
        <a href="#watch">'watch'</a>: { key:value, $route:function (newValue, oldValue) { /*监控路由*/ } }, //数据成员（3/6）
        <a href="#computed">'computed'</a>: { fun1:function () {} }, //数据成员（4/6）
        <a href="#props">'props'</a>: ['counts','ids'], //数据成员（5/6）
        <a href="#propsData">'propsData'</a>: null, //数据成员（5/6）
        <a href="#filters">'filters'</a>: {filter1:function(val){}}, //过虑器
        <a href="#directives">'directives'</a>: {}, //资源（2/3）
        <a href="#components">'components'</a>: null, //资源（2/3）
        <a href="#name">'name'</a>: null, //
        <a href="#parent">'parent'</a>: null, //
        <a href="#mixins">'mixins'</a>: null, //
        <a href="#model">'model'</a>: {'prop': '对应props的值','event': '响应事件'}, //处理自定义组件数据判定(v-model)时数据
        <a href="#extends">'extends'</a>: null, //
        <a href="#delimiters">'delimiters'</a>: null, //
        <a href="#functional">'functional'</a>: null, //
        <a href="#beforeCreate">'beforeCreate'</a>: function(){}, //生命周期钩子 事件配置之前被调用
        <a href="#created">'created'</a>: function(){}, //生命周期钩子 实例已经创建完成之后被调用, 可用于对vue实例数据进行初始化等操作
        <a href="#beforeMount">'beforeMount'</a>: function(){}, //生命周期钩子 在挂载开始之前被调用
        <a href="#mounted">'mounted'</a>: function(){}, //el 被新创建的 vm.$el 替换，并挂载到实例上去之后调用该钩子。
        <a href="#beforeUpdate">'beforeUpdate'</a>: function(){}, //数据更新时调用
        <a href="#updated">'updated'</a>: function(){}, //由于数据更改导致的虚拟
        <a href="#activated">'activated'</a>: function(){}, //keep-alive 组件激活时调用
        <a href="#deactivated">'deactivated'</a>: function(){}, //keep-alive 组件停用时调用。
        <a href="#beforeDestroy">'beforeDestroy'</a>: function(){}, // 实例销毁之前调用。在这一步，实例仍然完全可用。
        <a href="#destroyed">'destroyed'</a>: function(){}, // Vue 实例销毁后调用。调用后，Vue 实例指示的所有东西都会解绑定，所有的事件监听器会被移除，所有的子实例也会被销毁。
    });
    </pre>
    <pre>
        加载顺序 beforeCreate -&gt; created -&gt; beforeMount -&gt; mounted -&gt; ...
    </pre>
    <pre>
        Vue.<a href="#nextTick">nextTick</a>(callback); //当数据发生变化，更新后执行回调。
        this.<a href="#nextTick">$nextTick</a>(callback)，// 当dom发生变化，更新后执行的回调。
    </pre>
    <pre>
        Vue.<a href="#component">component</a>('component_name', {}); //组件
    </pre>
    <pre>
        this.<a href="#emit">$emit</a>(event, arg); //触发当前实例上的事件
        this.<a href="#component">$on</a>(event, fun); //监听当前实例上的自定义事件。事件可以由vm.$emit触发。回调函数会接收所有传入事件触发函数的额外参数。
    </pre>
    

    <dl>
        <dt> <h5><a name="el">$emit/$on 参数</a> </h5> </dt>
        <dd>
            <div class="demo" >
                <h2><a name="emit">$emit事件</a></h2>
                <code></code>
                <div>
                    <div id="vueEmit">
                        <div>父组件的toCity，{{toCity}}</div>
                        <cp_emit :data="toCity" @change="setCity"> </cp_emit>
                    </div>
                </div>
<script >
    // 组件
    Vue.component('cp_emit', {
        'template' : ` <div >
                        <h3>父组件传给子组件的toCity : {{data}}</h3> 
                        <br/>
                        <button @click='select("大连")'>点击此处将“大连”, 发射给父组件</button>
                      </div>
                    `
        , methods : {
            select : function(val) {
                let data = {cityname: val };
                //select事件触发后，自动触发change事件
                this.$emit('change', data);
            }
        }
        , created : function(){
            console.log( this.data );
        }
        // 用来接收父组件传给子组件的数据
        , props:['data'] 
    });

    // 主控件
    new Vue({
        'el' : '#vueEmit'
        , 'data' : {toCity:'深圳'}
        , 'methods' : {
            'setCity':function(e){
                this.toCity = e.cityname;
            }
        }
    });
</script>
        </div>
            
        </dd>
    </dl>




    <div class="demo" >
        <h2><a name="nextTick">vue 渲染完成 nextTick事件</a></h2>
        <code></code>
        <div>
            <ul id="demo_nextTick">
                <li v-for="item in list">{{item}}</li>
                <li ><a class="btn" @click="push">Add</a></li>
            </ul>
        </div>
<script >
    var demo_nextTick = new Vue({
        el:'#demo_nextTick',
        data:{
            list:[0,1,2]
        },
        methods:{
            push:function(){
                this.list.push( this.list.length );
                // this.nextTick(function(){
                //     alert('数据已经更新')
                // });
                this.$nextTick(function(){
                    console.log('v-for渲染已经完成')
                })
                console.log('数据添加完成')
            }
        }
    });
    //当数据发生变化，更新后执行回调。
    Vue.nextTick(function(){
        console.log('数据已经更新！');
    });
</script>
    </div>


    <dl>
        <dt> <h5><a name="el">el 参数</a> </h5> </dt>
        <dd>
            提供一个在页面上已存在的 DOM 元素作为 Vue 实例的挂载目标。
            
        </dd>
    </dl>


    <dl>
        <dt> <h5><a name="template">template 参数</a> </h5> </dt>
        <dd>
            一个字符串模板作为 Vue 实例的标识使用。模板将会 替换 挂载的元素。挂载元素的内容都将被忽略，除非模板的内容有分发 slot
            <p>格式一， 字符串（只能拥有一个根节点）如</p>
            <pre>
                &lt;template id="vuetpl"&gt;
                    &lt;h1&gt;new 1&lt;/h1&gt;
                    &lt;h2&gt;new 2&lt;/h2&gt;
                    &lt;h3&gt;new 3&lt;/h3&gt;
                &lt;/template&gt;
            </pre>
            <p>格式二， 输入模板ID号如 "#vuetpl"</p>
        </dd>
    </dl>


    <dl>
        <dt> <h5><a name="render">render 参数</a> </h5> </dt>
        <dd>
            function(createElement){ //render函数，用来渲染根组件<br>
            &nbsp;&nbsp;&nbsp;&nbsp;return createElement(App)<br>
            }<br>
            字符串模板的代替方案，允许你发挥 JavaScript 最大的编程能力。
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="data">data 参数</a> </h5> </dt>
        <dd>
            data():{ return{ } },<br />
            Vue实例的数据对象。Vue 将会递归将 data 的属性转换为 getter/setter，从而让 data 的属性能够响应数据变化
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="methods">methods 参数</a> </h5> </dt>
        <dd>
            methods:{ func(){ } }<br />
            methods将被混入到 Vue 实例中，可以直接通过 VM 实例访问这些方法，或者在指令表达式中使用<br />
            方法中的 this自动绑定为 Vue 实例<br />
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="watch">watch 参数</a> </h5> </dt>
        <dd>
            watch:{ key:value $route:function (newValue, oldValue) { //监控路由 } }<br />
            整个为一个对象，键是需要观察的表达式，值是对应回调函数
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="computed">computed 参数</a> </h5> </dt>
        <dd>
            computed:{ getTotalCount(){ const totalCount=0; return totalCount; } },<br />
            vue的计算属性，将被混入到 Vue 实例中。所有 getter 和 setter 的 this 上下文自动地绑定为 Vue 实例
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="props">props 参数</a> </h5> </dt>
        <dd>
            props:['counts','ids'],<br />
            用于父子组件的eventbus传值，是数组或对象，props的成员是子组件接收的来自父组件的数据
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="propsData">propsData 参数</a> </h5> </dt>
        <dd>
            创建实例时传递 props。主要作用是方便测试
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="filters">filters 参数</a> </h5> </dt>
        <dd>
            filters('filterName',(input,function(){ return newvalue }))<br />
            包含 Vue 实例可用过滤器的哈希表。
            <div class="demo" >
                <h2><a name="nextTick">filters 过虑器</a></h2>
                <code></code>
                <div>
                    <ul id="demo_filters">
                        <li>原数据：{{value}}</li>
                        <li>过虑数据：{{value|filter1}}</li>
                    </ul>
                </div>
<script >
    new Vue({
        el:'#demo_filters',
        data:{
            value:'1a2b3c4d5e6f7g'
        },
        filters : {
            filter1:function(e){ 
                return e.replace(/[^\d]+/gi, ''); 
            }
        },
        methods:{}
    });
</script>
            </div>  
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="directives">directives 参数</a> </h5> </dt>
        <dd>
            包含 Vue 实例可用指令的哈希表。
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="components">components 参数</a> </h5> </dt>
        <dd>（即该组件的子实例）这里是包含 Vue 实例可用组件的哈希表。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="name">name 参数</a> </h5> </dt>
        <dd>
            允许组件模板递归地调用自身。注意，组件在全局用 Vue.component() 注册时，全局 ID 自动作为组件的 name。
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="parent">parent 参数</a> </h5> </dt>
        <dd>指定已创建的实例之父实例，在两者之间建立父子关系。子实例可以用 this.$parent 访问父实例，子实例被推入父实例的 $children 数组中。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="mixins">mixins 参数</a> </h5> </dt>
        <dd>mixins 选项接受一个混合对象的数组。Mixin钩子按照传入顺序依次调用,并在调用组件自身的钩子之前被调用。</dd>
    </dl>
    <dl>
        <dt> <h5><a name="model">model 参数</a> </h5> </dt>
        <dd>
            <p>对组件进制v-model时，可用model进行接收数据。</p>
            <p>prop ： 将数据传输到props中的某一个变量</p>
            <p>event ： 响应事件</p>
        </dd>
        <dd>
            <div class="demo">
                            <h2><a >父子数据判定(model)</a></h2>
                            <code ></code>
                            <div>
                                <ul id="demo_model">
                                    父：<input type="text" v-model="title">
                                    <vue_cp_model v-model="title"></vue_cp_model>
                                </ul>
                            </div>
            <script>
Vue.component('vue_cp_model', {
    template :  '<div>子：<input type="text" v-model="data"></div>'
    , 'data' : function(){ return {data:null}; }
    , 'methods' : {

    }
    , 'props':['data']
    , 'model':{
        'prop': 'data'
        ,'event': ''
    }
});                
new Vue({
    'el': '#demo_model'
    ,'data': {title:'this is test model'}
});
            </script>
            </div>            
        </dd>
    </dl>

    <dl>
        <dt> <h5><a name="extends">extends 参数</a> </h5> </dt>
        <dd>允许声明扩展另一个组件。这主要是为了便于扩展单文件组件。这和 mixins 类似，区别在于，组件自身的选项会比要扩展的源组件具有更高的优先级。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="delimiters">delimiters 参数</a> </h5> </dt>
        <dd>改变纯文本插入分隔符。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="functional">functional 参数</a> </h5> </dt>
        <dd>使组件无状态（没有 data ）和无实例（没有 this 上下文）。他们用一个简单的 render 函数返回虚拟节点使他们更容易渲染。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="beforeCreate">beforeCreate 函数</a> </h5> </dt>
        <dd>在实例初始化之后，数据观测(data observer) 和 event/watcher 事件配置之前被调用。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="created">created 函数</a> </h5> </dt>
        <dd> 实例已经创建完成之后被调用。在这一步，实例已完成以下的配置：数据观测(data observer)，属性和方法的运算， watch/event 事件回调。然而，挂载阶段还没开始，$el 属性目前不可见</dd>
    </dl>

    <dl>
        <dt> <h5><a name="beforeMount">beforeMount 函数</a> </h5> </dt>
        <dd>在挂载开始之前被调用：相关的 render 函数首次被调用。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="mounted">mounted 函数</a> </h5> </dt>
        <dd>el 被新创建的 vm.$el 替换，并挂载到实例上去之后调用该钩子。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="beforeUpdate">beforeUpdate 函数</a> </h5> </dt>
        <dd>数据更新时调用，发生在虚拟 DOM 重新渲染和打补丁之前。你可以在这个钩子中进一步地更改状态，这不会触发附加的重渲染过程。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="updated">updated 函数</a> </h5> </dt>
        <dd>由于数据更改导致的虚拟 DOM 重新渲染和打补丁，在这之后会调用该钩子。当这个钩子被调用时，组件 DOM 已经更新，所以你现在可以执行依赖于 DOM 的操作</dd>
        必须先设置好的data变量数据, 在改变data数据并且重新渲染完成之后,才会触发updated方法，
        只改变data数据但不渲染页面不会触发.
    </dl>

    <dl>
        <dt> <h5><a name="activated">activated 函数</a> </h5> </dt>
        <dd>keep-alive 组件激活时调用</dd>
    </dl>

    <dl>
        <dt> <h5><a name="deactivated">deactivated 函数</a> </h5> </dt>
        <dd>keep-alive 组件停用时调用。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="beforeDestroy">beforeDestroy 函数</a> </h5> </dt>
        <dd>实例销毁之前调用。在这一步，实例仍然完全可用。</dd>
    </dl>

    <dl>
        <dt> <h5><a name="destroyed">destroyed 函数</a> </h5> </dt>
        <dd>Vue 实例销毁后调用。调用后，Vue 实例指示的所有东西都会解绑定，所有的事件监听器会被移除，所有的子实例也会被销毁。</dd>
    </dl>

<dl>
        <dt> <h5><a name="component">component 组件开发</a> </h5> </dt>
        <dd>
            <div class="demo" >
                <h2><a name="nextTick">父子通信</a></h2>
                <code></code>
                <div>
                    <ul id="demo_component_p2c">
                        <li>{{list}}</li>
                        <li>
                            <p2c :list="list"  > </p2c>
                        </li>
                        <li>
                            子组件通过props来接收父控件传过来的参数
                        </li>
                    </ul>
                </div>
<script >
    Vue.component('p2c', {
        template:`<div>
                这是子组件点击触发<a href="javascript:void(0)" @click="pushData">pushData</a>
                <p>通过this.$emit向父控件传递消息</p>
            </div>`
        , data:function(){ return {idx:0}; }
        , methods:{
            'pushData':function(){ 
                this.list.push(parseInt(Math.random()*100));
            }
        }
        , props: ['list'] //方法一
        // ,props: {'childCom':''} //方法二
    });
    new Vue({
        el:'#demo_component_p2c',
        data:{
            list:['a','b']
        },
        methods:{}
    });
</script>
            </div>            
        </dd>
        <dd>
            <div class="demo" >
                <h2><a name="nextTick">子父通信</a></h2>
                <code></code>
                <div>
                    <ul id="demo_component">
                        <li>{{list}}</li>
                        <li>
                            <child  @change="push"> </child>
                        </li>
                        <li>
                            子组件通过自定义change方法，调用父组件影响方法并传入参数
                        </li>
                    </ul>
                </div>
<script >
    Vue.component('child', {
        template:`<div>
                这是子组件点击触发<a href="javascript:void(0)" @click="pushData">pushData</a>
                <p>通过this.$emit向父控件传递消息</p>
            </div>`
        , data:function(){ return {idx:0}; }
        , methods:{
            'pushData':function(){ this.$emit('change', this.idx++); }
        }
    });
    new Vue({
        el:'#demo_component',
        data:{
            list:['a','b']
        },
        methods:{
            push:function(idx){this.list.push(idx); }
        }
    });
</script>
            </div>            
        </dd>
        <dd>
            <div class="demo" >
                <h2><a name="nextTick">带有v-model组件通信</a></h2>
                <code></code>
                <div>
                    <div id="demo_component_v_model">
                        <p >{{name}}</p>
                        <p >{{email}}</p>
                        <demo_component_v_model  v-model="" > </demo_component_v_model>
                    </div>
                    <p>带有v-model的父组件通过绑定的value值（即v-model的绑定值）传给子组件，子组件通过 prop接收一个 value;</p>
                    <p>子组件利用 $emit 触发 input 事件，并传入新值value给父组件；</p>
                </div>
<script >
    Vue.component('demo_component_v_model', {
        template:`<div>
                这是子组件点击触发<a href="javascript:void(0)" @click="pushData">pushData</a>
                <p>通过this.$emit向父控件传递消息</p>
            </div>`
        , data:function(){ return {idx:0}; }
        , methods:{
            'pushData':function(){ this.$emit('change', this.idx++); }
        }
    });
    new Vue({
        el:'#demo_component_v_model',
        data:{
            name:'rimke'
            , email:'rimke@163.com'
        },
        methods:{
            push:function(idx){this.list.push(idx); }
        }
    });
</script>
            </div>            
        </dd>
    </dl>

    <dl>
        <dt>v-pre 不解析vue 标签{{}}</dt>
        <dd>
           当不需要解析vue 标签时，可以在容器加上v-pre属性。
        </dd>
    </dl>


</div>

    <script>
        $('.demo').each(function(){
            var jsstr = $(this).find('>script').html();
            if(!jsstr)return;
            jsstr = jsstr.replace(/</gi, '&lt;');
            jsstr = jsstr.replace(/>/gi, '&gt;');
            jsstr = jsstr.replace(/ /gi, '&nbsp');
            // jsstr = jsstr.replace(/\t/gi, '&nbsp&nbsp&nbsp&nbsp');
            // jsstr = jsstr.replace(/\n/gi, '<br />');
            var hcode = $(this).find('>code');
            hcode.html( jsstr );
            ET(hcode);

        });
    </script>